#include "Common.h"

int main(int argc, char *argv[])
{    
    // Database Variables
    //--------------------------------------------------------------------------------------------------------------------------------------------
    sqlite3 *db;    // This is the database in the code
    char *err_msg = 0;
    // sqlite3_stmt *res;
    //--------------------------------------------------------------------------------------------------------------------------------------------
    
    // Create and fill the database
    //--------------------------------------------------------------------------------------------------------------------------------------------
    CreateAndFillDB(&db, err_msg);
    //--------------------------------------------------------------------------------------------------------------------------------------------

    // Server INET6 Variables
    //--------------------------------------------------------------------------------------------------------------------------------------------
    pthread_t INET_Server_Thread;
    struct INET_arg_struct INET_arguments;
    //--------------------------------------------------------------------------------------------------------------------------------------------

    // Mechanism to exit the program
    //--------------------------------------------------------------------------------------------------------------------------------------------
    char salir[MAXLINE];
    int exitAllThreads = 0;
    //--------------------------------------------------------------------------------------------------------------------------------------------

    // Verify arguments and fill argument structure for threads
    //--------------------------------------------------------------------------------------------------------------------------------------------
    verifyArguments(argc, argv);

    strcpy(INET_arguments.IPV4_Server_Address, argv[1]);
    INET_arguments.IPV4_iport = (short unsigned int)atoi(argv[2]);
    INET_arguments.db = &db;
    INET_arguments.maxClientes = DB_CONETCIONS;  // Assuming this is a constant value
    INET_arguments.salir = &exitAllThreads;
    //--------------------------------------------------------------------------------------------------------------------------------------------

    // Launch threads 
    //--------------------------------------------------------------------------------------------------------------------------------------------
    // INET
    pthread_create(&INET_Server_Thread, NULL, INET_Server_Code, &INET_arguments);
    //--------------------------------------------------------------------------------------------------------------------------------------------

    // Enter an infinite loop to keep the program running until the user decides to exit
    //--------------------------------------------------------------------------------------------------------------------------------------------
    while (!exitAllThreads)
    {
        // To determine if the user wants to exit, a string is received from stdin
        //----------------------------------------------------------------------------------------------------------------------------------------
        printf("Enter 'salir' at any time to close the server program\n");
        safeGetString(salir, MAXLINE);
        if (!strcmp(salir, "salir\n"))
        {
            exitAllThreads = 1; // -> Exit
            // Before exiting, wait until all other threads finish execution
            //----------------------------------------------------------------------------------------------------------------------------------------
            pthread_join(INET_Server_Thread, NULL);
            //----------------------------------------------------------------------------------------------------------------------------------------
        }
        else
        {
            printf("You entered %s\n", salir);
        }
        //----------------------------------------------------------------------------------------------------------------------------------------
    }
    //--------------------------------------------------------------------------------------------------------------------------------------------
}
